"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Federation = void 0;
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = require("@soft-stech/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta");
const base_1 = require("@soft-stech/base");
const validate_1 = require("@soft-stech/validate");
const schemaId = "rabbitmq.com.v1beta1.Federation";
const schema = {
    "type": "object",
    "properties": {
        "apiVersion": {
            "type": "string",
            "enum": [
                "rabbitmq.com/v1beta1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "Federation"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        },
        "spec": {
            "properties": {
                "ackMode": {
                    "enum": [
                        "on-confirm",
                        "on-publish",
                        "no-ack"
                    ],
                    "type": "string",
                    "nullable": true
                },
                "exchange": {
                    "type": "string",
                    "nullable": true
                },
                "expires": {
                    "type": "integer",
                    "nullable": true
                },
                "maxHops": {
                    "type": "integer",
                    "nullable": true
                },
                "messageTTL": {
                    "type": "integer",
                    "nullable": true
                },
                "name": {
                    "type": "string"
                },
                "prefetch-count": {
                    "type": "integer",
                    "nullable": true
                },
                "queue": {
                    "type": "string",
                    "nullable": true
                },
                "rabbitmqClusterReference": {
                    "properties": {
                        "connectionSecret": {
                            "properties": {
                                "name": {
                                    "type": "string",
                                    "nullable": true
                                }
                            },
                            "type": "object",
                            "nullable": true
                        },
                        "name": {
                            "type": "string",
                            "nullable": true
                        },
                        "namespace": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object"
                },
                "reconnectDelay": {
                    "type": "integer",
                    "nullable": true
                },
                "trustUserId": {
                    "type": "boolean",
                    "nullable": true
                },
                "uriSecret": {
                    "properties": {
                        "name": {
                            "type": "string",
                            "nullable": true
                        }
                    },
                    "type": "object"
                },
                "vhost": {
                    "default": "/",
                    "type": "string",
                    "nullable": true
                }
            },
            "required": [
                "name",
                "rabbitmqClusterReference",
                "uriSecret"
            ],
            "type": "object",
            "nullable": true
        },
        "status": {
            "properties": {
                "conditions": {
                    "items": {
                        "properties": {
                            "lastTransitionTime": {
                                "format": "date-time",
                                "type": "string",
                                "nullable": true
                            },
                            "message": {
                                "type": "string",
                                "nullable": true
                            },
                            "reason": {
                                "type": "string",
                                "nullable": true
                            },
                            "status": {
                                "type": "string"
                            },
                            "type": {
                                "type": "string"
                            }
                        },
                        "required": [
                            "status",
                            "type"
                        ],
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "observedGeneration": {
                    "format": "int64",
                    "type": "integer",
                    "nullable": true
                }
            },
            "type": "object",
            "nullable": true
        }
    },
    "required": [
        "apiVersion",
        "kind"
    ]
};
/**
 * Federation is the Schema for the federations API
 */
class Federation extends base_1.Model {
    constructor(data) {
        super({
            apiVersion: Federation.apiVersion,
            kind: Federation.kind,
            ...data
        });
    }
}
exports.Federation = Federation;
Federation.apiVersion = "rabbitmq.com/v1beta1";
Federation.kind = "Federation";
Federation.is = (0, base_1.createTypeMetaGuard)(Federation);
(0, base_1.setSchema)(Federation, schemaId, () => {
    (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.addSchema)();
    (0, validate_1.register)(schemaId, schema);
});
